/*********************************************/
/*                                    	     */
/*   TEST.C  Version 1.00           	     */
/*                                    	     */
/*   C Packet Driver library  demonstration  */
/*                                    	     */
/*   Libor Hlavac, (c) 1993                  */
/*                                    	     */
/*********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "pktc.h"

#define MY_TYPE 0x321

uchar my_addr  [ADDRLEN];
uchar dest_addr[ADDRLEN] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};

packet pkt_out;
packet pkt_in;

unsigned handle;
unsigned length;

int result;

char z;

void error (int error_code);

void main (void)
{
  clrscr();
  result = pkt_init(MY_TYPE,&handle);
  if(result) error(result);
  result = pkt_get_addr(handle,my_addr);
  if(result) error(result);
  printf("My     address is: ");
  write_addr(my_addr);
  printf("\nTarget address is: ");
  write_addr(dest_addr);
  printf("\n");

  while(1)
  { if(kbhit())
    { z = getch();
      if(z == 0x1B) break;
      memcpy(pkt_out.dest,  dest_addr, ADDRLEN);
      memcpy(pkt_out.source,my_addr, ADDRLEN);
      pkt_out.type = MY_TYPE;
      pkt_out.data[0] = z;
      result = pkt_send(&pkt_out, HEADERLEN + 1);
      if(result) error(result);
    }

    if(!pkt_rec(&pkt_in, &length))
    { printf("Received from: ");
      write_addr(pkt_in.source);
      printf(" Data: %02X %c\n",pkt_in.data[0],pkt_in.data[0]);
    }
  }
  result = pkt_close(handle);
  if(result) error(result);
}

void error (int error_code)
{
  if(error_code != E_NO_DRIVER) pkt_close(handle);
  printf("Errror: %s !\n",error_str[error_code]);
  exit(1);
}

