{*******************************************************}
{*                                    	               *}
{*   TEST.PAS  Version 1.00           	               *}
{*                                    	               *}
{*   Turbo PASCAL Packet Driver library demonstration  *}
{*                                    	               *}
{*   Libor Hlavac, (c) 1993                            *}
{*                                    	               *}
{*******************************************************}

uses
  Crt,
  PktPas;

const
  MyType   = $321;
  DestAddr : TAddr = ($FF, $FF, $FF, $FF, $FF, $FF);

var
  MyAddr : TAddr;
  PktOut : TPacket;
  PktIn  : TPacket;
  Handle : THandle;
  Len    : word;
  Result : integer;
  z      : char;

procedure Error (ErrorCode : integer);
begin
  if ErrorCode <> E_NO_DRIVER then
    Result := PktClose (Handle);
  Write('Error: ',ErrorStr[ErrorCode]);
  WriteLn;
  halt(1);
end;


begin
  ClrScr;

  Result := PktInit (MyType, Handle);
  if Result <> 0 then Error (Result);

  Result := PktGetAddr (Handle, MyAddr);
  if Result <> 0 then Error (Result);

  Write('My     address is: ');
  WriteAddr(MyAddr);
  WriteLn;
  Write('Target address is: ');
  WriteAddr(DestAddr);
  WriteLn;

  z := ' ';

  repeat
    if KeyPressed then
    begin
      z := ReadKey;
      if ord(z) <> $1B then
      begin
        PktOut.Dest    := DestAddr;
        PktOut.Source  := MyAddr;
        PktOut.Typ     := MyType;
        PktOut.Data[1] := ord(z);
        Result := PktSend(PktOut, HEADERLEN + 1);
        if Result <> 0 then Error (Result);
      end;
    end;

    Result := PktRec(PktIn, Len);
    if Result = 0 then
    begin
      Write('Received from: ');
      WriteAddr(PktIn.Source);
      Write(' Data: ');
      WriteHex(PktIn.Data[1]);
      Write(' ',Chr(PktIn.Data[1]));
      WriteLn;
    end;
  until ord(z) = $1B;

  Result := PktClose(Handle);
  if Result <> 0 then Error(Result);
end.
