///////////////////////////////////////////////////////////////////
//
// PAKET DRIVER API
//
// Popis funkci je v dokumentaci k pktdrv
//
///////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <dos.h>
#include <string.h>

#include "pktdrvr.h"

int Derr=0;				// Chyby

// ZAREGISTROVANI L3 FUNKCE

int access_type(int intno,int if_class,int if_type,int if_number,
	char *type,unsigned typelen, void _far _saveregs _loadds (*receiver)(void))
{
	union REGS regs;
	struct SREGS sregs;

	segread(&sregs);
	regs.h.dl = if_number;		// Number
	sregs.ds = FP_SEG(type);	// Packet type template
	regs.x.si = FP_OFF(type);
	regs.x.cx = typelen;		// Length of type
	sregs.es = FP_SEG(receiver);	// Address of receive handler
	regs.x.di = FP_OFF(receiver);
	regs.x.bx = if_type;		// Type
	regs.h.ah = ACCESS_TYPE;	// Access_type() function
	regs.h.al = if_class;		// Class
	int86x(intno,&regs,&regs,&sregs);
	if(regs.x.cflag){
		Derr = regs.h.dh;
		return -1;
	} else
		return regs.x.ax;
}

// DEREGISTROVANI L3 FUNKCE

int release_type(int intno, int handle)
{
	union REGS regs;

	regs.x.bx = handle;
	regs.h.ah = RELEASE_TYPE;
	int86(intno,&regs,&regs);
	if(regs.x.cflag){
		Derr = regs.h.dh;
		return -1;
	} else
		return 0;
}

// ODESLANI PAKETU

int send_pkt(int intno, char *buffer, unsigned length)
{
	union REGS regs;
	struct SREGS sregs;

	segread(&sregs);
	sregs.ds = FP_SEG(buffer);
	sregs.es = FP_SEG(buffer); // for buggy univation pkt driver - CDY
	regs.x.si = FP_OFF(buffer);
	regs.x.cx = length;
	regs.h.ah = SEND_PKT;
	int86x(intno,&regs,&regs,&sregs);
	if(regs.x.cflag){
		Derr = regs.h.dh;
		return -1;
	} else
		return 0;
}

// ZJISTENI INFORMACI O PKTDRV

int driver_info(int intno,int handle,
	int *if_version,int *if_class,int *if_type,int *if_number,int *if_basic)
{
	union REGS regs;

	regs.x.bx = handle;
	regs.h.ah = DRIVER_INFO;
	regs.h.al = 0xff;
	int86(intno,&regs,&regs);
	if(regs.x.cflag){
		Derr = regs.h.dh;
		return -1;
	}
	if(if_version != NULL)
		*if_version = regs.x.bx;
	if(if_class != NULL)
		*if_class = regs.h.ch;
	if(if_type != NULL)
		*if_type = regs.x.dx;
	if(if_number != NULL)
		*if_number = regs.h.cl;
	if(if_basic != NULL)
		*if_basic = regs.h.al;
	return 0;
}

// ZJISTENI PARAMETRU PKTDRV

int get_parameters(int intno)
{
	union REGS regs;
	struct SREGS sregs;
	unsigned char far *param;

	regs.h.ah = GET_PARAMETERS;
	int86x(intno,&regs,&regs,&sregs);
	if(regs.x.cflag){
		Derr = regs.h.dh;
		return -1;
	}
	param = MK_FP(sregs.es, regs.x.di);
	return param[4] + 256 * param[5];
}

// ZJISTENI L2 ADRESY

int get_address(int intno, int handle, char *buffer, int len)
{
	union REGS regs;
	struct SREGS sregs;

	segread(&sregs);
	sregs.es = FP_SEG(buffer);
	regs.x.di = FP_OFF(buffer);
	regs.x.cx = len;
	regs.x.bx = handle;
	regs.h.ah = GET_ADDRESS;
	int86x(intno,&regs,&regs,&sregs);
	if(regs.x.cflag){
		Derr = regs.h.dh;
		return -1;
	}
	return 0;
}
