; *************************************************************************
; * SCRREC - prijem obsahu textove casti videoram ze vzdaleneho pocitace  *
; *          s vyuzitim sluzeb paket driveru                              *
; *************************************************************************

jumps

		include	defs.asm		; ruzne definice

code		segment byte public
		assume	cs:code, ds:code

int_pkt		macro                           ; makro pro volani
		pushf                           ; makro pro volani
		cli
		call	driver
		endm


		org	100h

start:          jmp	begin

my_type		dw	0321h                   ; zvoleny typ paketu
driver		dd	?                       ; tady bude adresa entry
						; point paket driveru

sign		db	'PKT DRVR'		; signatura paket driveru
sign_len	equ	$ - sign                ; a jeji delka

my_buffer	db	1024 dup(?)             ; buffer pro vysilani
rec_buffer	db	1024 dup(?)             ; a pro prijem

addr_from	db	?,?,?,?,?,?             ; tady bude nase adresa

						; posila se vsem takze
						; cilova adresa je broadcast
addr_to		db	0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh
addr_len	equ	6                       ; delka adresy

video_seg	equ	0B800h                  ; segment video pameti (Color)
line_len	equ	160                     ; delka jedne radky

can_next	db 	?                       ; semafor

timeout		dw	?                       ; timeout pro odpovedi

handle		dw	?                       ; prideleny handle

err_int		db	'Packet driver not found !',13,10,'$'

begin:		call	find_int                ; pokusime se najit paket
						; driver
		jnc	int_ok
		lea	dx, err_int
		mov	ah, 09h
		int	21h
		mov	ax, 4C00h
		int 	21h

int_ok:		call	access                  ; inicializace typu
		call	get_addr                ; nacteni adresy

		jmp     to_send                 ; posli zadost

start_loop:     xor	ax,ax                   ; uloz timeout
		mov	es,ax
		mov	ax, es:[46Ch]
		add	ax, 9
		mov	timeout, ax

main_loop:	cmp	can_next, 0             ; muzeme dalsi zadost ?
		jne	to_send
		mov	ah, 1                   ; jinak precti klavesnici
		int	16h
		jz	no_key
		mov	ah, 0
		int	16h
		cmp	al, 1Bh                 ; <ESC> = konec
		je 	main_end
no_key:         mov	ax, es:[46Ch]           ; zkontroluj timeout
		cmp	ax, timeout
		jne	main_loop

to_send:        call	req_send                ; vysli zadost
		mov	can_next, 0             ; zakaz dalsi
		jmp	start_loop              ; a znovu

main_end:	call	release                 ; uvolneni typu
		mov	ax, 4C00h
		int	21h                     ; konec


req_send	proc	near			; zaslani zadosti

		mov	ax, cs
		mov	ds, ax
		mov	es, ax

		mov	di, offset my_buffer
		mov	si, offset addr_to
		mov	cx, addr_len
		rep 	movsb                   ; kopirovani adresata
		mov	si, offset addr_from
		mov	cx, addr_len
		rep 	movsb                   ; kopirovani odesilatele

		mov	ax, my_type             ; kopirovani typu
		mov	[di], ax

		mov	al, 0FFh                ; je to zadost !
		mov	[di + 2], al

		mov	ax, cs
		mov	ds, ax
		mov	es, ax
		mov	ah, 4
		mov     si, offset my_buffer
		mov	cx, 2 * addr_len + 3
		int_pkt                        	; send
		call	fatal_error
		ret
req_send	endp


receiver	proc	far			; prijimaci rutina
		cmp	ax, 0                   ; prvni volani ?
		jne	second
		push	cs
		pop	es                      ; vrat pozici bufferu
		mov	di, offset rec_buffer
		ret

second:		mov	al, ds:[si + 14]        ; vyzvedni cislo radky
		cmp	al, 25
		jnc	rec_end
		mov	ah, line_len
		mul	ah
		mov	di, ax
		mov	ax, video_seg           ; vypocti pozici
		mov	es, ax
		mov	cx, line_len
		add	si, 15
		rep	movsb                   ; prenes
		mov	cs:can_next, 1          ; muzeme dalsi zadost
rec_end:	ret
receiver	endp

find_int	proc	near                    ; vyhledani paket driveru
		mov	dx, 60h                 ; 60h - 80h

find_loop:	mov	al, dl
		mov	ah, 35h
		int	21h
		mov     word ptr driver    , bx ; adresy obsluh
		mov	word ptr driver + 2, es
		mov	di, bx
		add	di, 3
		mov	si, offset sign
		mov	cx, sign_len
		repe    cmpsb                   ; porovnej singaturu
		je	found_int
		inc	dl
		cmp	dl, 80h
		jc	find_loop
		stc
		ret

found_int:	clc
		ret
find_int	endp


access		proc	near                    ; inicializace
		mov	ax, 01FFh
		int_pkt                         ; get_info
		call	fatal_error
		mov	ah, 2
		mov	al, ch
		mov	bx, 0FFFFh
		mov	dl, cl
		push	cs
		pop	ds
		mov	si, offset my_type
		mov	cx, SIZE my_type
		push	cs
		pop	es
		mov	di, offset receiver
		int_pkt                       	; access_type
		call	fatal_error
		mov	handle, ax
		ret
access		endp

get_addr	proc	near                   	; zjisteni adresy
		mov	ax, cs
		mov	es, ax
		mov	ah, 6
		mov	bx, handle
		mov	di, offset addr_from
		mov	cx, addr_len
		int_pkt                         ; get_address
		call	fatal_error
		ret
get_addr	endp

release		proc	near                    ; uvolneni
		mov	ah, 3
		mov	bx, handle
		int_pkt                         ; release_type
		call	fatal_error
		ret
release		endp

		include	chrout.asm		; vystup znaku pro pkterr.asm
		include	pkterr.asm		; osetreni chyb

code		ends

		end	start
