; ************************************************************************
; * SCRSEND - zaslani obsahu textove casti videoram na vzdaleny pocitac  *
; *           s vyuzitim sluzeb paket driveru                            *
; ************************************************************************

jumps

		include	defs.asm		; ruzne definice

code		segment byte public
		assume	cs:code, ds:code

int_pkt		macro                           ; makro pro volani
		pushf                           ; paket driveru
		cli
		call	driver
		endm


		org	100h

start:          jmp	begin

my_type		dw	0321h                   ; zvoleny typ paketu

driver		dd	?			; tady bude adresa entry
						; point paket driveru

sign		db	'PKT DRVR'              ; signatura paket driveru
sign_len	equ	$ - sign                ; a jeji delka

my_buffer	db	1024 dup(?)             ; buffer pro vysilani
rec_buffer	db	1024 dup(?)             ; a pro prijem

addr_from	db	?,?,?,?,?,?             ; tady bude nase adresa

						; posila se vsem takze
						; cilova adresa je broadcast
addr_to		db	0FFh, 0FFh, 0FFh, 0FFh, 0FFh, 0FFh

addr_len	equ	6                       ; delka adresy

video_seg	equ	0B800h                  ; segment video pameti (Color)
line_len	equ	160			; delka jedne radky

next_segm	db	?			; cislo pristi radky
can_next	db	?                       ; semafor

handle		dw	?                       ; prideleny handle

err_int		db	'Packet driver not found !',13,10,'$'

begin:		call	find_int                ; pokusime se najit paket
						; driver
		jnc	int_ok
		lea	dx, err_int
		mov	ah, 09h
		int	21h
		mov	ax, 4C01h
		int 	21h

int_ok:		call	access                  ; inicializace typu
		call	get_addr                ; nacteni adresy

main_loop:      mov	next_segm, 0            ; od prvniho radku
		mov	can_next, 0             ; cekame na zadost
screen_loop:    mov	ah, 1                   ; cteme klavesnici
		int	16h
		jz	no_key
		mov	ah, 0
		int	16h
		cmp	al, 1Bh                 ; <ESC> = konec
		je 	main_end
no_key:		cmp	can_next, 0             ; muzeme posilat ?
		je	screen_loop             ; ne tak na zacatek
		call	segm_send               ; jinak posli radek
		mov	can_next, 0             ; ted posilat nemuzeme
		inc	next_segm               ; priste dalsi radek
		cmp	next_segm, 25           ; uz je to cele ?
		jc	screen_loop

main_end:	call	release                 ; uvolneni typu
		mov	ax, 4C00h
		int	21h                     ; konec !


segm_send	proc	near                    ; zaslani radku

segm_loop:      mov	ax, cs
		mov	ds, ax
		mov	es, ax

		mov	di, offset my_buffer
		mov	si, offset addr_to
		mov	cx, addr_len
		rep 	movsb                   ; kopirovani cilove adresy
		mov	si, offset addr_from
		mov	cx, addr_len
		rep 	movsb                   ; kopirovani adresy
						; odesilatele

		mov	ax, my_type             ; kopirovani typu
		mov	[di], ax

		mov	al, next_segm           ; vlozeni cisla radku
		mov	[di + 2], al

		mov	ah, line_len
		mul	ah
		mov	si, ax
		mov	ax, video_seg
		mov	ds, ax
		mov	cx, line_len
		add	di, 3
		rep	movsb                   ; kopirovani radku

		mov	ax, cs
		mov	ds, ax
		mov	es, ax
		mov	ah, 4
		mov     si, offset my_buffer
		mov	cx, 2 * addr_len + 3 + line_len
		int_pkt                         ; a posli
		call	fatal_error
		ret
segm_send	endp

						; tato rutina je volana pri
receiver	proc	far               	; prijmu paketu
		cmp	ax, 0                   ; prvni volani ?
		jne	second
		push	cs                      ; ano vrat adresu bufferu
		pop	es
		mov	di, offset rec_buffer
		ret
						; podruhe po zkopirovani
second:		mov	al, cs:[rec_buffer + 14]
		cmp	al, 0FFh                ; je to zadost ?
		je	allow_next
		ret

allow_next:	mov	cs:can_next, 1          ; muzeme dalsi radek
		ret
receiver	endp


find_int	proc	near			; vyhleda paket driver int
		mov	dx, 60h                 ; hleda se mezi 60h a 80h

find_loop:	mov	al, dl
		mov	ah, 35h
		int	21h
		mov     word ptr driver    , bx ; adresa obsluhy
		mov	word ptr driver + 2, es
		mov	di, bx
		add	di, 3
		mov	si, offset sign
		mov	cx, sign_len
		repe    cmpsb                   ; porovnej signaturu
		je	found_int
		inc	dl
		cmp	dl, 80h
		jc	find_loop
		stc
		ret

found_int:	clc
		ret
find_int	endp


access		proc	near                    ; inicializace
		mov	ax, 01FFh
		int_pkt                         ; get_info
		call	fatal_error
		mov	ah, 2
		mov	al, ch
		mov	bx, 0FFFFh
		mov	dl, cl
		push	cs
		pop	ds
		mov	si, offset my_type
		mov	cx, SIZE my_type
		push	cs
		pop	es
		mov	di, offset receiver
		int_pkt                         ; access_type
		call	fatal_error
		mov	handle, ax
		ret
access		endp


get_addr	proc	near            	; zjisteni adresy
		mov	ax, cs
		mov	es, ax
		mov	ah, 6
		mov	bx, handle
		mov	di, offset addr_from
		mov	cx, addr_len
		int_pkt                         ; get_addres
		call	fatal_error
		ret
get_addr	endp


release		proc	near			; uvolneni
		mov	ah, 3
		mov	bx, handle
		int_pkt                         ; release_type
		call	fatal_error
		ret
release		endp

		include	pkterr.asm		; obsluha chyb
		include	chrout.asm		; vypis znaku pro pkterr.asm

code		ends

		end	start
